package meerkat.crypto;

import com.google.protobuf.Message;
import static meerkat.protobuf.Crypto.*;

/**
 * Created by talm on 11/2/15.
 */
public interface Encryption {
    /**
     * Encrypt the serialized form of a message plaintext.
     * @param plaintext
     * @param rnd
     * @return
     */
    RerandomizableEncryptedMessage encrypt(Message plaintext, EncryptionRandomness rnd); // TODO: type of exception; throws

    RerandomizableEncryptedMessage rerandomize(RerandomizableEncryptedMessage msg, EncryptionRandomness rnd);

}
